#include <iostream>
#include <queue>
using namespace std;

const int MAXP = 10;

string names[MAXP];

struct team {
    int p1, p2;
};
queue<team> *dyns = new queue<team>();
queue<int> q;


void update(int& o1, int& d1, int& o2, int& d2, team t1, team& t2, int currStreak, int& maxStreak)
{
    int tmp = o1;
    o1 = d1;
    d1 = tmp;
    q.push(d2);
    d2 = o2;
    o2 = q.front();
    q.pop();
    if (t2.p2 == d2)
        t2.p1 = t2.p2;                  // update order in which player entered team
    t2.p2 = o2;
    if (currStreak > maxStreak) {
        maxStreak = currStreak;
        dyns = new queue<team>();
        dyns->push(t1);
//cout << "pushing " << t1.p1 << ',' << t1.p2 << endl;
    }
    else if (currStreak == maxStreak) {
        dyns->push(t1);
//cout << "pushing " << t1.p1 << ',' << t1.p2 << endl;
    }
}

int main()
{
    int n;
    cin >> n;
    for(int i=0; i<n; i++)
        cin >> names[i];
    string s;
    cin >> s;
    int whtO=0, blkO=1, whtD=2, blkD=3;
    for(int i=4; i<n; i++)
        q.push(i);
//printqueue();

    int maxStreak = 0;
    int currStreak = 1;
    int t10=whtO, t11=whtD, tw0=blkO, tw1=blkD;
    team tw, tb;
    tw.p1 = whtO;
    tw.p2 = whtD;
    tb.p1 = blkO;
    tb.p2 = blkD;
    if (s[0] == 'W') {
        update(whtO, whtD, blkO, blkD, tw, tb, currStreak, maxStreak);
    }
    else {
        update(blkO, blkD, whtO, whtD, tb, tw, currStreak, maxStreak);
    }
    char prev = s[0];
    for(int i=1; i<s.length(); i++) {
        char curr = s[i];
        if (curr == prev) {
            currStreak++;
            if (curr == 'W') {
                update(whtO, whtD, blkO, blkD, tw, tb, currStreak, maxStreak);
            }
            else {
                update(blkO, blkD, whtO, whtD, tb, tw, currStreak, maxStreak);
            }
        }
        else {
            currStreak = 1;
            if (curr == 'W') {
                update(whtO, whtD, blkO, blkD, tw, tb, currStreak, maxStreak);
            }
            else {
                update(blkO, blkD, whtO, whtD, tb, tw, currStreak, maxStreak);
            }
        }
        prev = curr;
    }
    while (!dyns->empty()) {
        team t = dyns->front();
        dyns->pop();
        cout << names[t.p1] << ' ' << names[t.p2] << endl;
    }
}
